﻿<?xml version="1.0" encoding="utf-8"?>
<root>
   <definevalue name="HUGE_VAL" value="">
      <summary text="float 型で表現できるとは限らない正の double 型の式。無限大またはそれに類する大きな値"/>
   </definevalue>
	<function name="acos" type="double" content="acos(double x)">
	   <summary text="アークコサインを計算します。アークコサイン（ラジアン）値を返します。"/>
	   <argument text="コサインの値"/>
	</function>
	<function name="asin" type="double" content="asin(double x)">
	   <summary text="アークサインを計算します。アークサイン（ラジアン）値を返します。"/>
	   <argument text="サインの値"/>
	</function>
	<function name="atan" type="double" content="atan(double x)">
	   <summary text="アークタンジェントを計算します。アークタンジェント（ラジアン）値を返します。"/>
	   <argument text="タンジェントの値"/>
	</function>
	<function name="atan2" type="double" content="atan2(double y, double x)">
	   <summary text="アークタンジェントを計算します。アークタンジェント（ラジアン）値を返します。引数xが0でも計算できます。"/>
	   <argument text="縦の値"/>
	   <argument text="横の値"/>
	</function>
	<function name="cos" type="double" content="cos(double x)">
	   <summary text="コサインを計算します。コサイン値を返します。"/>
	   <argument text="ラジアン単位の角度"/>
	</function>
	<function name="sin" type="double" content="sin(double x)">
	   <summary text="サインを計算します。サイン値を返します。"/>
	   <argument text="ラジアン単位の角度"/>
	</function>
	<function name="tan" type="double" content="tan(double x)">
	   <summary text="タンジェントを計算します。タンジェント値を返します。"/>
	   <argument text="ラジアン単位の角度"/>
	</function>
	<function name="cosh" type="double" content="cosh(double x)">
	   <summary text="ハイパボリックコサイン値を計算します。ハイパボリックコサイン値を返します。"/>
	   <argument text="ラジアン単位の角度"/>
	</function>
	<function name="sinh" type="double" content="sinh(double x)">
	   <summary text="ハイパボリックサイン値を計算します。ハイパボリックサイン値を返します。"/>
	   <argument text="ラジアン単位の角度"/>
	</function>
	<function name="tanh" type="double" content="tanh(double x)">
	   <summary text="ハイパボリックタンジェント値を計算します。ハイパボリックタンジェント値を返します。"/>
	   <argument text="ラジアン単位の角度"/>
	</function>
	<function name="exp" type="double" content="exp(double x)">
	   <summary text="指数を計算します。自然対数の底のx乗を返します。"/>
	   <argument text="実数値"/>
	</function>
	<function name="frexp" type="double" content="frexp(double value, int *exp)">
	   <summary text="浮動小数点値の指数部と仮数部を求めます。仮数部分の値を返します。"/>
	   <argument text="任意の実数値"/>
	   <argument text="返される指数部分の値"/>
	</function>
	<function name="ldexp" type="double" content="ldexp(double x, int exp)">
	   <summary text="仮数部と指数部から浮動小数点値を求めます。合成された浮動小数点値を返します。"/>
	   <argument text="仮数部"/>
	   <argument text="指数部"/>
	</function>
	<function name="log" type="double" content="log(double x)">
	   <summary text="自然対数を求めます。自然対数値を返します。"/>
	   <argument text="任意の実数値"/>
	</function>
	<function name="log10" type="double" content="log10(double x)">
	   <summary text="常用対数を求めます。常用対数値を返します。"/>
	   <argument text="任意の実数値"/>
	</function>
	<function name="modf" type="double" content="modf(double value, double *iptr)">
	   <summary text="実数値を整数部分と小数部分に分けます。小数部分の値を返します。"/>
	   <argument text="任意の実数値"/>
	   <argument text="返される整数部部分の値"/>
	</function>
	<function name="pow" type="double" content="pow(double x, double y)">
	   <summary text="累乗を求めます。x を y 乗した値を返します。"/>
	   <argument text="累乗される値"/>
	   <argument text="指数"/>
	</function>
	<function name="sqrt" type="double" content="sqrt(double x)">
	   <summary text="平方根を計算します。平方根を返します。"/>
	   <argument text="任意の実数値"/>
	</function>
	<function name="ceil" type="double" content="ceil(double x)">
	   <summary text="実数値を整数値に丸めます。入力値以上の整数値を返します。"/>
	   <argument text="任意の実数値"/>
	</function>
	<function name="fabs" type="double" content="fabs(double x)">
	   <summary text="絶対値を計算します。絶対値を返します。"/>
	   <argument text="実数値"/>
	</function>
	<function name="floor" type="double" content="floor(double x)">
	   <summary text="実数値を整数値に丸めます。入力値以下の整数値を返します。"/>
	   <argument text="任意の実数値"/>
	</function>
	<function name="fmod" type="double" content="fmod(double x, double y)">
	   <summary text="実数値の余りを求めます。余りを返します。"/>
	   <argument text="割られる数"/>
	   <argument text="割る数"/>
	</function>
</root>