﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ParseExtension.RegularExpressions
{
    class ParserRegexFuncContent : ParserRegexContent
    {
        public Func<string, bool> Func
        {
            get;
            private set;
        }

        public ParserRegexFuncContent(Func<string, bool> func)
        {
            Func = func;
        }

        public override bool IsMatch(ParseToken token)
        {
            if (Func != null)
            {
                return Func(token.Token);
            }
            return false;
        }
    }
}
